package constructs;

import java.text.MessageFormat;

import error.LispException;
import file.FilePosition;

public interface TokenFactory {

    Token createToken(String text, FilePosition position);

    Token createEOFToken(FilePosition position);

    public static class BadCharacterException extends LispException {

        private static final long serialVersionUID = 1L;

        private String text;
        private FilePosition position;

        public BadCharacterException(String text, FilePosition position) {
            this.text = text;
            this.position = position;
        }

        @Override
        public int getSeverity() {
            return 0;
        }

        @Override
        public String getMessage() {
            return MessageFormat.format("illegal character >>{0}<< - line {1}, column {2}", text,
                                        position.getLineNumber(), position.getColumnNumber());
        }

    }
}
